﻿using Syncfusion.UI.Xaml.Charts;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Diagnostics;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections;

namespace Sample1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void chart_PanChanging(object sender, PanChangingEventArgs e)
        {
           
        }
    }

    public class SfChartExt : SfChart
    {
        protected override void OnMouseDown(MouseButtonEventArgs e)
        {
            base.OnMouseDown(e);

            if (e.ChangedButton == MouseButton.Middle && e.ButtonState == MouseButtonState.Pressed)
                foreach (var behavior in Behaviors)
                {
                    if (behavior is ChartZoomPanBehaviorExt)
                        (behavior as ChartZoomPanBehaviorExt).MouseLeftButtonDown(e);
                }
        }

        protected override void OnMouseUp(MouseButtonEventArgs e)
        {
            base.OnMouseUp(e);

            if (e.ChangedButton == MouseButton.Middle && e.ButtonState == MouseButtonState.Released)
                foreach (var behavior in Behaviors)
                {
                    if (behavior is ChartZoomPanBehaviorExt)
                        (behavior as ChartZoomPanBehaviorExt).MouseLeftButtonUp(e);

                }
        }
    }

    public class ChartZoomPanBehaviorExt : ChartZoomPanBehavior
    {
        public void MouseLeftButtonUp(MouseButtonEventArgs e)
        {
            OnMouseLeftButtonUp(e);
        }

        public void MouseLeftButtonDown(MouseButtonEventArgs e)
        {
            OnMouseLeftButtonDown(e);
        }
    }

    public class Model
    {
        public double XValue { get; set; }
        public double YValue { get; set; }
    }

    public class ViewModel
    {
        public ViewModel()
        {
            GenerateData();           
        }

        public void GenerateData()
        {
            Data = new ObservableCollection<Model>();
            Random rd = new Random();
            for (int i = 0; i < 6; i++)
            {
                Data.Add(new Model()
                {
                    XValue = i,
                    YValue = rd.Next(0, 50)
                });
            }
        }

        private ObservableCollection<Model> data;

        public ObservableCollection<Model> Data
        {
            get { return data; }
            set { data = value;  }
        }

        
       
    }
    
}
